/*
 *    This file is a part of the SteamWar software.
 *
 *    Copyright (C) 2022  SteamWar.de-Serverteam
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU Affero General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.sql;

import de.steamwar.sql.internal.Field;
import de.steamwar.sql.internal.SelectStatement;
import de.steamwar.sql.internal.Statement;
import de.steamwar.sql.internal.Table;
import lombok.AllArgsConstructor;

@AllArgsConstructor
public class SchemElo {
    private static final int ELO_DEFAULT = 1000;

    private static final Table<SchemElo> table = new Table<>(SchemElo.class);
    private static final SelectStatement<SchemElo> select = table.select(Table.PRIMARY);
    private static final Statement setElo = table.insertAll();

    public static int getElo(SchematicNode node, int season) {
        SchemElo elo = select.select(node, season);
        return elo != null ? elo.elo : 0;
    }

    public static int getCurrentElo(int schemID) {
        SchemElo elo = select.select(schemID, Season.getSeason());
        return elo != null ? elo.elo : ELO_DEFAULT;
    }

    public static void setElo(int schemID, int elo) {
        setElo.update(schemID, elo, Season.getSeason());
    }

    @Field(keys = {Table.PRIMARY})
    private final int schemId;
    @Field
    private final int elo;
    @Field(keys = {Table.PRIMARY})
    private final int season;
}
